alter table audio_samples add rank INTEGER NULL;
alter table audio_samples add time_difference INTEGER NOT NULL DEFAULT 0;
alter table audio_samples add chart_point_index INTEGER NOT NULL DEFAULT 0;

CREATE INDEX ranked_samples_session_id ON ranked_samples (session_id);
CREATE INDEX ranked_samples_date ON ranked_samples (date);

update audio_samples set rank = (
    select rank from ranked_samples
    where audio_samples.session_id = ranked_samples.session_id
    and audio_samples.start_time = ranked_samples.date
);
update audio_samples set time_difference = ifnull((
    select time_difference from ranked_samples
    where audio_samples.session_id = ranked_samples.session_id
    and audio_samples.start_time = ranked_samples.date
), 0);
update audio_samples set chart_point_index = ifnull((
    select chart_point_index from ranked_samples
    where audio_samples.session_id = ranked_samples.session_id
    and audio_samples.start_time = ranked_samples.date
), 0);
drop table ranked_samples;