BEGIN TRANSACTION;

insert into sleep_influences(id,type,icon_id,custom,order_id) values('mouth_taping','remedy','MOUTH_TAPING','0','6.5');
insert into sleep_influences(id,type,icon_id,custom,order_id) values('snooor','remedy','SNOOOR','0','3.5');

ALTER TABLE chart_points ADD point_timestamp_seconds NUMERIC NOT NULL DEFAULT 0;
UPDATE chart_points SET point_time = point_time + pause_before;
UPDATE chart_points SET pause_before = 0;
CREATE INDEX index_point_timestamp_seconds ON chart_points(point_timestamp_seconds);

CREATE TABLE favorites (
    timestamp_seconds NUMERIC NOT NULL PRIMARY KEY,
    session_id INTEGER NOT NULL,
    FOREIGN KEY(session_id) REFERENCES sessions(id) ON DELETE CASCADE ON UPDATE CASCADE
);

CREATE TABLE audio_samples_new (
    start_time_seconds INTEGER NOT NULL PRIMARY KEY,
    audio_state TEXT NOT NULL,
    intensity NUMERIC NOT NULL,
    data_size INTEGER NOT NULL,
    audio_path TEXT,
    session_id INTEGER NOT NULL,
    chart_point_id INTEGER,
    file_path_grouped INTEGER NOT NULL DEFAULT 0,
    start_time_tz_offset INTEGER NULL,
    is_available_locally INTEGER NULL,
    rank INTEGER NULL,
    chart_point_index INTEGER NOT NULL DEFAULT 0,
    legacy_id INTEGER NOT NULL DEFAULT 0,
    FOREIGN KEY(session_id) REFERENCES sessions(id) ON DELETE CASCADE ON UPDATE CASCADE,
    FOREIGN KEY(chart_point_id) REFERENCES chart_points(id) ON DELETE CASCADE ON UPDATE CASCADE
);

UPDATE audio_samples SET start_time = start_time / 1000;

INSERT INTO favorites (timestamp_seconds, session_id)
SELECT start_time, session_id
FROM audio_samples
WHERE favorite != 0;

REPLACE INTO audio_samples_new(audio_state, start_time_seconds, intensity, data_size, audio_path, session_id, chart_point_id, file_path_grouped, start_time_tz_offset, is_available_locally, rank, chart_point_index, legacy_id)
SELECT audio_state, start_time, intensity, data_size, audio_path, session_id, chart_point_id, file_path_grouped, start_time_tz_offset, is_available_locally, rank, chart_point_index, id
FROM audio_samples;

DROP TABLE audio_samples;
ALTER TABLE audio_samples_new RENAME TO audio_samples;

CREATE INDEX index_start_time_seconds ON audio_samples(start_time_seconds);

COMMIT;